import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsArticleContent, CmsArticleContentParam } from './model';


/**
 * 分页查询文章记录表
 */
export async function pageCmsArticleContent(params: CmsArticleContentParam) {
  const res = await request.get<ApiResult<PageResult<CmsArticleContent>>>(
    '/cms/cms-article-content/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询文章记录表列表
 */
export async function listCmsArticleContent(params?: CmsArticleContentParam) {
  const res = await request.get<ApiResult<CmsArticleContent[]>>(
    '/cms/cms-article-content',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加文章记录表
 */
export async function addCmsArticleContent(data: CmsArticleContent) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-article-content',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改文章记录表
 */
export async function updateCmsArticleContent(data: CmsArticleContent) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-article-content',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除文章记录表
 */
export async function removeCmsArticleContent(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-article-content/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除文章记录表
 */
export async function removeBatchCmsArticleContent(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-article-content/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询文章记录表
 */
export async function getCmsArticleContent(id: number) {
  const res = await request.get<ApiResult<CmsArticleContent>>(
    '/cms/cms-article-content/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
